#!/bin/sh

sudo echo " "
echo "\n"

MYDIR=$(dirname "$0")

# remove driver
DRIVER_NAME="Audiojingle.driver"
DRIVER_INSTALL_PATH="/Library/Audio/Plug-Ins/HAL/${DRIVER_NAME}"



# remove helper plist
LAUNCHD_PLIST_INSTALL_PATH_1=/Library/LaunchDaemons
LAUNCHD_PLIST_INSTALL_PATH_2=/Library/LaunchAgents
LAUNCHD_PLIST_ID=com.audiojinglex.soundtree.agent
LAUNCHD_PLIST_FILENAME=${LAUNCHD_PLIST_ID}.plist
COREAUDIOD_PLIST="/System/Library/LaunchDaemons/com.apple.audio.coreaudiod.plist"

SRC_LAUNCHD_PLIST="${MYDIR}/${LAUNCHD_PLIST_FILENAME}"
DST_LAUNCHD_PLIST_1="${LAUNCHD_PLIST_INSTALL_PATH_1}/${LAUNCHD_PLIST_FILENAME}"
DST_LAUNCHD_PLIST_2="${LAUNCHD_PLIST_INSTALL_PATH_2}/${LAUNCHD_PLIST_FILENAME}"


echo "\033[32m @----------@->befor->uninstall \033[0m"
echo "ls -al@ /Library/Audio/Plug-Ins/HAL/"
ls -al@ /Library/Audio/Plug-Ins/HAL/
echo "\033[32m @----------@->befor->uninstall->driver->Audiojingle \033[0m"
ls -al@ /Library/Audio/Plug-Ins/HAL/Audiojingle.driver/Contents/MacOS/Audiojingle


echo "ls -al@ ${DST_LAUNCHD_PLIST_1}"
ls -al@ "${DST_LAUNCHD_PLIST_1}"
echo "\n"

#echo "ls -al@ ${DST_LAUNCHD_PLIST_2}"
ls -al@ "${DST_LAUNCHD_PLIST_2}"  &>/dev/null
echo "\n"





# remove driver
if [  -d "${DRIVER_INSTALL_PATH}" ]; then
  sudo /bin/chmod 0777 "${DRIVER_INSTALL_PATH}"
  sudo /bin/rm -rf "${DRIVER_INSTALL_PATH}" || exit 1
fi


# romove the plist.
if [ -e "${DST_LAUNCHD_PLIST_1}" ]; then
  sudo /bin/chmod 0777 "${DST_LAUNCHD_PLIST_1}"
  sudo /bin/rm -f "${DST_LAUNCHD_PLIST_1}"
fi

if [ -e "${DST_LAUNCHD_PLIST_2}" ]; then
  sudo /bin/chmod 0777 "${DST_LAUNCHD_PLIST_2}"
  sudo /bin/rm -f "${DST_LAUNCHD_PLIST_2}"  &>/dev/null
fi

echo "Removing launchd service."
sudo /bin/launchctl list | grep "${LAUNCHD_PLIST_ID}" >/dev/null && \
  (sudo /bin/launchctl bootout system "${DST_LAUNCHD_PLIST_1}" &>/dev/null || \
    # Try older versions of the command in case the user has an old version of launchctl.
    sudo /bin/launchctl unbootstrap system "${DST_LAUNCHD_PLIST_1}" &>/dev/null || \
    sudo /bin/launchctl unload "${DST_LAUNCHD_PLIST_1}" >/dev/null) || \
  echo "  Service does not running."

 
# The extra or-clauses are fallback versions of the command that restarts coreaudiod. Apparently
# some of these commands don't work with older versions of launchctl, so I figure there's no
# harm in trying a bunch of different ways (which should all work).
(sudo launchctl kickstart -k system/com.apple.audio.coreaudiod &>/dev/null || \
    sudo launchctl kill SIGTERM system/com.apple.audio.coreaudiod &>/dev/null || \
    sudo launchctl kill TERM system/com.apple.audio.coreaudiod &>/dev/null || \
    sudo launchctl kill 15 system/com.apple.audio.coreaudiod &>/dev/null || \
    sudo launchctl kill -15 system/com.apple.audio.coreaudiod &>/dev/null || \
    (sudo launchctl unload "${COREAUDIOD_PLIST}" &>/dev/null && \
        sudo launchctl load "${COREAUDIOD_PLIST}" &>/dev/null) || \
    sudo killall coreaudiod &>/dev/null) && \
    sleep 5
    
        
echo "restart coreaudio"

sleep 5
